{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Data.Curry_PropertyFile
  ( d_C_readPropertyFile
  , d_C_updatePropertyFile
  , d_C_getPropertyFromFile
  , d_C_getPropertiesFromFile )
  where

import Basics
import qualified Data.Curry_Char
import qualified Curry_Prelude
import qualified System.Curry_Directory
import qualified System.Curry_IO


d_C_readPropertyFile :: Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
d_C_readPropertyFile x1 cd cs = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  cd cs) (System.Curry_Directory.d_C_doesFileExist x1 cd cs) cd cs)
  (d_OP_readPropertyFile_dot_uscore_hash_lambda3 x1) cd cs

d_OP_readPropertyFile_dot_splitEqs_dot_2 :: Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_readPropertyFile_dot_splitEqs_dot_2 x1 cd cs = case x1 of
  Curry_Prelude.OP_List -> Curry_Prelude.OP_List
  Curry_Prelude.OP_Cons x2 x3 -> d_C__case_4 x2 x3 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_break (Curry_Prelude.d_C_flip (acceptCs id
    Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char)
    (Curry_Prelude.C_Char '='#)) cd cs) x2 cd cs) cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i
    (d_OP_readPropertyFile_dot_splitEqs_dot_2 l cd cs)
    (d_OP_readPropertyFile_dot_splitEqs_dot_2 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z ->
    d_OP_readPropertyFile_dot_splitEqs_dot_2 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x ->
    d_OP_readPropertyFile_dot_splitEqs_dot_2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Data.PropertyFile.readPropertyFile.splitEqs.2" [show x1] info)
  _ -> failCons cd (consFail "Data.PropertyFile.readPropertyFile.splitEqs.2"
    (showCons x1))

d_OP_readPropertyFile_dot_uscore_hash_lambda3 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)))
d_OP_readPropertyFile_dot_uscore_hash_lambda3 x1 x2 cd cs = case x2 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    cd cs) (System.Curry_IO.d_C_openFile x1 System.Curry_IO.C_ReadMode cd cs) cd
    cs) System.Curry_IO.d_C_hGetContents cd cs) cd cs)
    d_OP_readPropertyFile_dot_uscore_hash_lambda3_dot_uscore_hash_lambda6 cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
    cd cs) Curry_Prelude.OP_List cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i
    (d_OP_readPropertyFile_dot_uscore_hash_lambda3 x1 l cd cs)
    (d_OP_readPropertyFile_dot_uscore_hash_lambda3 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z ->
    d_OP_readPropertyFile_dot_uscore_hash_lambda3 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x ->
    d_OP_readPropertyFile_dot_uscore_hash_lambda3 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.PropertyFile.readPropertyFile._#lambda3" [show x1, show x2] info)
  _ -> failCons cd (consFail "Data.PropertyFile.readPropertyFile._#lambda3"
    (showCons x2))

d_OP_readPropertyFile_dot_uscore_hash_lambda3_dot_uscore_hash_lambda6 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
d_OP_readPropertyFile_dot_uscore_hash_lambda3_dot_uscore_hash_lambda6 x1 cd cs =
  let x2 = x1
  in Curry_Prelude.d_OP_dollar
  (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  cd cs) (Curry_Prelude.d_OP_dollar (Curry_Prelude.d_OP_dot
  d_OP_readPropertyFile_dot_splitEqs_dot_2 (Curry_Prelude.d_OP_dot
  (Curry_Prelude.d_C_filter
  d_OP_readPropertyFile_dot_uscore_hash_lambda3_dot_uscore_hash_lambda6_dot_uscore_hash_lambda8)
  Curry_Prelude.d_C_lines cd cs) cd cs) x2 cd cs) cd cs

d_OP_readPropertyFile_dot_uscore_hash_lambda3_dot_uscore_hash_lambda6_dot_uscore_hash_lambda8 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_readPropertyFile_dot_uscore_hash_lambda3_dot_uscore_hash_lambda6_dot_uscore_hash_lambda8 x1 cd cs =
  Curry_Prelude.d_OP_amp_amp (Curry_Prelude.d_C_not (Curry_Prelude.d_C_null x1
  cd cs) cd cs) (Curry_Prelude.d_C_isAlpha (Curry_Prelude.d_C_head x1 cd cs) cd
  cs) cd cs

d_C_updatePropertyFile :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_Prelude.OP_Unit
d_C_updatePropertyFile x1 x2 x3 cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  cd cs) (d_C_readPropertyFile x1 cd cs) cd cs)
  (d_OP_updatePropertyFile_dot_uscore_hash_lambda10 x1 x2 x3) cd cs

d_OP_updatePropertyFile_dot_uscore_hash_lambda10 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore
  -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_OP_updatePropertyFile_dot_uscore_hash_lambda10 x1 x2 x3 x4 cd cs = let x5 = x4
  in d_C__case_2 x5 x2 x3 x1
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Maybe
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char)
  (Curry_Prelude.d_C_lookup
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char) x2
  x5 cd cs) Curry_Prelude.C_Nothing cd cs) cd cs

d_C_changePropertyInFile :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_Prelude.OP_Unit
d_C_changePropertyInFile x1 x2 x3 cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  cd cs) (System.Curry_IO.d_C_openFile x1 System.Curry_IO.C_ReadMode cd cs) cd
  cs) System.Curry_IO.d_C_hGetContents cd cs) cd cs)
  (d_OP_changePropertyInFile_dot_uscore_hash_lambda13 x1 x2 x3) cd cs

d_OP_changePropertyInFile_dot_changeProp_dot_20 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_changePropertyInFile_dot_changeProp_dot_20 x1 x2 x3 cd cs =
  let x4 = Curry_Prelude.d_C_apply (Curry_Prelude.d_C_break
        (Curry_Prelude.d_C_flip (acceptCs id
        Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Char)
        (Curry_Prelude.C_Char '='#)) cd cs) x3 cd cs
      x5 = d_OP_changePropertyInFile_dot_changeProp_dot_20_dot_uscore_hash_selFP2_hash_s1
        x4 cd cs
      x6 = d_OP_changePropertyInFile_dot_changeProp_dot_20_dot_uscore_hash_selFP3_hash_s2
        x4 cd cs
  in d_C__case_1 x6 x3 x1 x5 x2 (Curry_Prelude.d_OP_bar_bar
  (Curry_Prelude.d_C_null x3 cd cs) (Curry_Prelude.d_OP_bar_bar
  (Curry_Prelude.d_C_not (Curry_Prelude.d_C_isAlpha (Curry_Prelude.d_C_head x3
  cd cs) cd cs) cd cs) (Curry_Prelude.d_C_null x6 cd cs) cd cs) cd cs) cd cs

d_OP_changePropertyInFile_dot_changeProp_dot_20_dot_uscore_hash_selFP2_hash_s1 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_changePropertyInFile_dot_changeProp_dot_20_dot_uscore_hash_selFP2_hash_s1 x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_changePropertyInFile_dot_changeProp_dot_20_dot_uscore_hash_selFP2_hash_s1
    l cd cs)
    (d_OP_changePropertyInFile_dot_changeProp_dot_20_dot_uscore_hash_selFP2_hash_s1
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_changePropertyInFile_dot_changeProp_dot_20_dot_uscore_hash_selFP2_hash_s1
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_changePropertyInFile_dot_changeProp_dot_20_dot_uscore_hash_selFP2_hash_s1
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.PropertyFile.changePropertyInFile.changeProp.20._#selFP2#s1" [show x1]
    info)
  _ -> failCons cd (consFail
    "Data.PropertyFile.changePropertyInFile.changeProp.20._#selFP2#s1" (showCons
    x1))

d_OP_changePropertyInFile_dot_changeProp_dot_20_dot_uscore_hash_selFP3_hash_s2 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_changePropertyInFile_dot_changeProp_dot_20_dot_uscore_hash_selFP3_hash_s2 x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_changePropertyInFile_dot_changeProp_dot_20_dot_uscore_hash_selFP3_hash_s2
    l cd cs)
    (d_OP_changePropertyInFile_dot_changeProp_dot_20_dot_uscore_hash_selFP3_hash_s2
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_changePropertyInFile_dot_changeProp_dot_20_dot_uscore_hash_selFP3_hash_s2
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_changePropertyInFile_dot_changeProp_dot_20_dot_uscore_hash_selFP3_hash_s2
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.PropertyFile.changePropertyInFile.changeProp.20._#selFP3#s2" [show x1]
    info)
  _ -> failCons cd (consFail
    "Data.PropertyFile.changePropertyInFile.changeProp.20._#selFP3#s2" (showCons
    x1))

d_OP_changePropertyInFile_dot_uscore_hash_lambda13 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.C_IO
  Curry_Prelude.OP_Unit
d_OP_changePropertyInFile_dot_uscore_hash_lambda13 x1 x2 x3 x4 cd cs =
  let x5 = x4
  in Curry_Prelude.d_C_writeFile x1 (Curry_Prelude.d_OP_dollar
  (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_unlines cd cs)
  (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_map
  (d_OP_changePropertyInFile_dot_changeProp_dot_20 x2 x3))
  Curry_Prelude.d_C_lines cd cs) cd cs) x5 cd cs) cd cs

d_C_getPropertyFromFile :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.C_Maybe (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_C_getPropertyFromFile x1 x2 cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  cd cs) (d_C_readPropertyFile x1 cd cs) cd cs)
  (d_OP_getPropertyFromFile_dot_uscore_hash_lambda16 x2) cd cs

d_OP_getPropertyFromFile_dot_uscore_hash_lambda16 :: Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Cover -> ConstStore -> Curry_Prelude.C_IO
  (Curry_Prelude.C_Maybe (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_getPropertyFromFile_dot_uscore_hash_lambda16 x1 x2 cd cs = let x3 = x2
  in Curry_Prelude.d_OP_dollar
  (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  cd cs) (Curry_Prelude.d_C_lookup
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char)
  (Curry_Prelude.d_C_map Data.Curry_Char.d_C_toLower x1 cd cs)
  (Curry_Prelude.d_C_map
  d_OP_getPropertyFromFile_dot_uscore_hash_lambda16_dot_uscore_hash_lambda18 x3
  cd cs) cd cs) cd cs

d_OP_getPropertyFromFile_dot_uscore_hash_lambda16_dot_uscore_hash_lambda18 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_OP_getPropertyFromFile_dot_uscore_hash_lambda16_dot_uscore_hash_lambda18 x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> Curry_Prelude.OP_Tuple2
    (Curry_Prelude.d_C_map Data.Curry_Char.d_C_toLower x2 cd cs) x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_getPropertyFromFile_dot_uscore_hash_lambda16_dot_uscore_hash_lambda18
    l cd cs)
    (d_OP_getPropertyFromFile_dot_uscore_hash_lambda16_dot_uscore_hash_lambda18
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_getPropertyFromFile_dot_uscore_hash_lambda16_dot_uscore_hash_lambda18 z
    cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_getPropertyFromFile_dot_uscore_hash_lambda16_dot_uscore_hash_lambda18 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.PropertyFile.getPropertyFromFile._#lambda16._#lambda18" [show x1]
    info)
  _ -> failCons cd (consFail
    "Data.PropertyFile.getPropertyFromFile._#lambda16._#lambda18" (showCons x1))

d_C_getPropertiesFromFile :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover
  -> ConstStore -> Curry_Prelude.C_IO (Curry_Prelude.OP_List
  (Curry_Prelude.C_Maybe (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
d_C_getPropertiesFromFile x1 x2 cd cs = Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_gt_gt_eq_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  cd cs) (d_C_readPropertyFile x1 cd cs) cd cs)
  (d_OP_getPropertiesFromFile_dot_uscore_hash_lambda20 x2) cd cs

d_OP_getPropertiesFromFile_dot_uscore_hash_lambda20 :: Curry_Prelude.OP_List
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore
  -> Curry_Prelude.C_IO (Curry_Prelude.OP_List (Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
d_OP_getPropertiesFromFile_dot_uscore_hash_lambda20 x1 x2 cd cs = let x3 = x2
  in Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_return_hash_Prelude_dot_Monad_hash_Prelude_dot_IO
  cd cs) (Curry_Prelude.d_C_map (Curry_Prelude.d_C_flip (acceptCs id
  (Curry_Prelude.d_C_lookup
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lbracket_rbracket
  Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char)))
  (Curry_Prelude.d_C_map
  d_OP_getPropertiesFromFile_dot_uscore_hash_lambda20_dot_uscore_hash_lambda22
  x3 cd cs)) (Curry_Prelude.d_C_map (Curry_Prelude.d_C_map
  Data.Curry_Char.d_C_toLower) x1 cd cs) cd cs) cd cs

d_OP_getPropertiesFromFile_dot_uscore_hash_lambda20_dot_uscore_hash_lambda22 :: Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
d_OP_getPropertiesFromFile_dot_uscore_hash_lambda20_dot_uscore_hash_lambda22 x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> Curry_Prelude.OP_Tuple2
    (Curry_Prelude.d_C_map Data.Curry_Char.d_C_toLower x2 cd cs) x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_getPropertiesFromFile_dot_uscore_hash_lambda20_dot_uscore_hash_lambda22
    l cd cs)
    (d_OP_getPropertiesFromFile_dot_uscore_hash_lambda20_dot_uscore_hash_lambda22
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_getPropertiesFromFile_dot_uscore_hash_lambda20_dot_uscore_hash_lambda22
    z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_getPropertiesFromFile_dot_uscore_hash_lambda20_dot_uscore_hash_lambda22
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.PropertyFile.getPropertiesFromFile._#lambda20._#lambda22" [show x1]
    info)
  _ -> failCons cd (consFail
    "Data.PropertyFile.getPropertiesFromFile._#lambda20._#lambda22" (showCons
    x1))

d_C__case_4 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C__case_4 x2 x3 x6 cd cs = case x6 of
  Curry_Prelude.OP_Tuple2 x4 x5 -> d_C__case_3 x3 x4 x5 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C__case_4 x2 x3 l cd
    cs) (d_C__case_4 x2 x3 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z -> d_C__case_4 x2
    x3 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x -> d_C__case_4 x2 x3
    e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.PropertyFile._case_4" [show x2, show x3, show x6] info)
  _ -> failCons cd (consFail "Data.PropertyFile._case_4" (showCons x6))

d_C__case_3 :: Curry_Prelude.OP_List (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_C__case_3 x3 x4 x5 cd cs = case x5 of
  Curry_Prelude.OP_Cons x6 x7 -> Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2
    x4 x7) (d_OP_readPropertyFile_dot_splitEqs_dot_2 x3 cd cs)
  Curry_Prelude.OP_List -> d_OP_readPropertyFile_dot_splitEqs_dot_2 x3 cd cs
  Curry_Prelude.Choice_OP_List d i l r -> narrow d i (d_C__case_3 x3 x4 l cd cs)
    (d_C__case_3 x3 x4 r cd cs)
  Curry_Prelude.Choices_OP_List d i xs -> narrows cs d i (\z -> d_C__case_3 x3
    x4 z cd cs) xs
  Curry_Prelude.Guard_OP_List d c e -> guardCons d c ((\x -> d_C__case_3 x3 x4 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_List d info -> failCons d (traceFail
    "Data.PropertyFile._case_3" [show x3, show x4, show x5] info)
  _ -> failCons cd (consFail "Data.PropertyFile._case_3" (showCons x5))

d_C__case_2 :: Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.C_IO Curry_Prelude.OP_Unit
d_C__case_2 x5 x2 x3 x1 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.d_C_appendFile x1
    (Curry_Prelude.d_OP_plus_plus x2 (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString "=") (Curry_Prelude.d_OP_plus_plus x3
    (Curry_Prelude.toCurryString "\n") cd cs) cd cs) cd cs) cd cs
  Curry_Prelude.C_False -> d_C_changePropertyInFile x1 x2 x3 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_2 x5 x2 x3 x1 l
    cd cs) (d_C__case_2 x5 x2 x3 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_2 x5 x2
    x3 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_2 x5 x2 x3
    x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.PropertyFile._case_2" [show x5, show x2, show x3, show x1, show x6]
    info)
  _ -> failCons cd (consFail "Data.PropertyFile._case_2" (showCons x6))

d_C__case_1 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C__case_1 x6 x3 x1 x5 x2 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> x3
  Curry_Prelude.C_False -> d_C__case_0 x1 x5 x3 x2
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket
    Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Prelude_dot_Char x5
    x1 cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_1 x6 x3 x1 x5 x2
    l cd cs) (d_C__case_1 x6 x3 x1 x5 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_1 x6 x3
    x1 x5 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_1 x6 x3 x1
    x5 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.PropertyFile._case_1" [show x6, show x3, show x1, show x5, show x2
    , show x7] info)
  _ -> failCons cd (consFail "Data.PropertyFile._case_1" (showCons x7))

d_C__case_0 :: Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_C__case_0 x1 x5 x3 x2 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus x5
    (Curry_Prelude.d_OP_plus_plus (Curry_Prelude.toCurryString "=") x2 cd cs) cd
    cs
  Curry_Prelude.C_False -> x3
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_0 x1 x5 x3 x2 l
    cd cs) (d_C__case_0 x1 x5 x3 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_0 x1 x5
    x3 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_0 x1 x5 x3
    x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail
    "Data.PropertyFile._case_0" [show x1, show x5, show x3, show x2, show x6]
    info)
  _ -> failCons cd (consFail "Data.PropertyFile._case_0" (showCons x6))

