{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Data.Set.Curry_RBTree
  ( d_C_empty
  , nd_C_empty
  , d_C_emptyOrd
  , nd_C_emptyOrd
  , d_C_null
  , nd_C_null
  , d_C_member
  , nd_C_member
  , d_C_insert
  , nd_C_insert
  , d_C_insertMulti
  , nd_C_insertMulti
  , d_C_delete
  , nd_C_delete
  , d_C_toList
  , nd_C_toList
  , d_C_union
  , nd_C_union
  , d_C_intersection
  , nd_C_intersection
  , d_C_sortBy
  , nd_C_sortBy )
  where

import Basics
import qualified Data.Curry_Maybe
import qualified Data.Curry_RedBlackTree
import qualified Curry_Prelude


d_C_empty :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> Cover
  -> ConstStore -> (t0 -> Cover -> ConstStore -> t0 -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool) -> Cover -> ConstStore
  -> Data.Curry_RedBlackTree.C_RedBlackTree t0
d_C_empty x1 cd cs = Data.Curry_RedBlackTree.d_C_empty (Curry_Prelude.d_OP_eq_eq
  x1 cd cs) (Curry_Prelude.d_OP_eq_eq x1 cd cs)

nd_C_empty :: forall t0 . (Curry_Prelude.Curry t0) => Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> IDSupply -> Cover -> ConstStore
  -> Func (Func t0 (Func t0 Curry_Prelude.C_Bool))
  (Data.Curry_RedBlackTree.C_RedBlackTree t0)
nd_C_empty x1 s cd cs = let s2 = s
  in s2 `seq` (let s0 = leftSupply s2
                   s1 = rightSupply s2
  in s0 `seq` (s1 `seq` wrapNX id (Data.Curry_RedBlackTree.nd_C_empty
  (Curry_Prelude.nd_OP_eq_eq x1 s0 cd cs) (Curry_Prelude.nd_OP_eq_eq x1 s1 cd
  cs))))

d_C_emptyOrd :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Cover
  -> ConstStore -> Data.Curry_RedBlackTree.C_RedBlackTree t0
d_C_emptyOrd x1 cd cs = Curry_Prelude.d_C_apply (d_C_empty
  (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Ord_hash_Prelude_dot_Eq x1
  cd cs) cd cs) (Curry_Prelude.d_OP_lt x1 cd cs) cd cs

nd_C_emptyOrd :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> IDSupply
  -> Cover -> ConstStore -> Data.Curry_RedBlackTree.C_RedBlackTree t0
nd_C_emptyOrd x1 s cd cs = let s5 = s
  in s5 `seq` (let s4 = leftSupply s5
                   s6 = rightSupply s5
                   s2 = leftSupply s6
                   s3 = rightSupply s6
  in s4 `seq` (s6 `seq` (s2 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
  (let s1 = leftSupply s2
       s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C_empty
  (Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Ord_hash_Prelude_dot_Eq x1
  s0 cd cs) s1 cd cs)) (Curry_Prelude.nd_OP_lt x1 s3 cd cs) s4 cd cs))))

d_C_null :: Cover -> ConstStore -> forall t0 . (Curry_Prelude.Curry
  t0) => Data.Curry_RedBlackTree.C_RedBlackTree t0 -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C_null cd cs = Data.Curry_RedBlackTree.d_C_isEmpty

nd_C_null :: IDSupply -> Cover -> ConstStore -> forall t0 . (Curry_Prelude.Curry
  t0) => Func (Data.Curry_RedBlackTree.C_RedBlackTree t0) Curry_Prelude.C_Bool
nd_C_null s cd cs = wrapNX id Data.Curry_RedBlackTree.nd_C_isEmpty

d_C_member :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> Cover -> ConstStore
  -> Data.Curry_RedBlackTree.C_RedBlackTree t0 -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C_member x1 cd cs = Curry_Prelude.d_OP_dot Data.Curry_Maybe.d_C_isJust
  (Data.Curry_RedBlackTree.d_C_lookup x1) cd cs

nd_C_member :: forall t0 . (Curry_Prelude.Curry t0) => t0 -> IDSupply -> Cover
  -> ConstStore -> Func (Data.Curry_RedBlackTree.C_RedBlackTree t0)
  Curry_Prelude.C_Bool
nd_C_member x1 s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.nd_OP_dot (wrapDX id Data.Curry_Maybe.d_C_isJust)
  (wrapNX id (Data.Curry_RedBlackTree.nd_C_lookup x1)) s0 cd cs

d_C_insert :: Cover -> ConstStore -> forall t0 . (Curry_Prelude.Curry t0) => t0
  -> Cover -> ConstStore -> Data.Curry_RedBlackTree.C_RedBlackTree t0 -> Cover
  -> ConstStore -> Data.Curry_RedBlackTree.C_RedBlackTree t0
d_C_insert cd cs = acceptCs id Data.Curry_RedBlackTree.d_C_update

nd_C_insert :: IDSupply -> Cover -> ConstStore
  -> forall t0 . (Curry_Prelude.Curry t0) => Func t0 (Func
  (Data.Curry_RedBlackTree.C_RedBlackTree t0)
  (Data.Curry_RedBlackTree.C_RedBlackTree t0))
nd_C_insert s cd cs = wrapDX (wrapNX id) (acceptCs id
  Data.Curry_RedBlackTree.nd_C_update)

d_C_insertMulti :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> t0 -> Cover -> ConstStore
  -> Data.Curry_RedBlackTree.C_RedBlackTree t0 -> Cover -> ConstStore
  -> Data.Curry_RedBlackTree.C_RedBlackTree t0
d_C_insertMulti x1 x2 cd cs = Curry_Prelude.d_OP_dot
  (Data.Curry_RedBlackTree.d_C_setInsertEquivalence (Curry_Prelude.d_OP_eq_eq x1
  cd cs)) (Curry_Prelude.d_OP_dot (Data.Curry_RedBlackTree.d_C_update x2)
  (Data.Curry_RedBlackTree.d_C_setInsertEquivalence (acceptCs id
  d_OP_insertMulti_dot_uscore_hash_lambda1)) cd cs) cd cs

nd_C_insertMulti :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> t0
  -> IDSupply -> Cover -> ConstStore -> Func
  (Data.Curry_RedBlackTree.C_RedBlackTree t0)
  (Data.Curry_RedBlackTree.C_RedBlackTree t0)
nd_C_insertMulti x1 x2 s cd cs = let s3 = s
  in s3 `seq` (let s2 = leftSupply s3
                   s4 = rightSupply s3
                   s0 = leftSupply s4
                   s1 = rightSupply s4
  in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` Curry_Prelude.nd_OP_dot (wrapNX id
  (Data.Curry_RedBlackTree.nd_C_setInsertEquivalence (Curry_Prelude.nd_OP_eq_eq
  x1 s0 cd cs))) (Curry_Prelude.nd_OP_dot (wrapNX id
  (Data.Curry_RedBlackTree.nd_C_update x2)) (wrapNX id
  (Data.Curry_RedBlackTree.nd_C_setInsertEquivalence (wrapDX (wrapDX id)
  (acceptCs id d_OP_insertMulti_dot_uscore_hash_lambda1)))) s1 cd cs) s2 cd
  cs))))

d_OP_insertMulti_dot_uscore_hash_lambda1 :: forall t0 . (Curry_Prelude.Curry
  t0) => t0 -> t0 -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_insertMulti_dot_uscore_hash_lambda1 x1 x2 cd cs = Curry_Prelude.C_False

d_C_delete :: Cover -> ConstStore -> forall t0 . (Curry_Prelude.Curry t0) => t0
  -> Cover -> ConstStore -> Data.Curry_RedBlackTree.C_RedBlackTree t0 -> Cover
  -> ConstStore -> Data.Curry_RedBlackTree.C_RedBlackTree t0
d_C_delete cd cs = acceptCs id Data.Curry_RedBlackTree.d_C_delete

nd_C_delete :: IDSupply -> Cover -> ConstStore
  -> forall t0 . (Curry_Prelude.Curry t0) => Func t0 (Func
  (Data.Curry_RedBlackTree.C_RedBlackTree t0)
  (Data.Curry_RedBlackTree.C_RedBlackTree t0))
nd_C_delete s cd cs = wrapDX (wrapNX id) (acceptCs id
  Data.Curry_RedBlackTree.nd_C_delete)

d_C_toList :: Cover -> ConstStore -> forall t0 . (Curry_Prelude.Curry
  t0) => Data.Curry_RedBlackTree.C_RedBlackTree t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
d_C_toList cd cs = Data.Curry_RedBlackTree.d_C_toList

nd_C_toList :: IDSupply -> Cover -> ConstStore
  -> forall t0 . (Curry_Prelude.Curry t0) => Func
  (Data.Curry_RedBlackTree.C_RedBlackTree t0) (Curry_Prelude.OP_List t0)
nd_C_toList s cd cs = wrapNX id Data.Curry_RedBlackTree.nd_C_toList

d_C_union :: forall t0 . (Curry_Prelude.Curry
  t0) => Data.Curry_RedBlackTree.C_RedBlackTree t0
  -> Data.Curry_RedBlackTree.C_RedBlackTree t0 -> Cover -> ConstStore
  -> Data.Curry_RedBlackTree.C_RedBlackTree t0
d_C_union x1 x2 cd cs = Curry_Prelude.d_C_foldr (d_C_insert cd cs) x2
  (Curry_Prelude.d_C_apply (d_C_toList cd cs) x1 cd cs) cd cs

nd_C_union :: forall t0 . (Curry_Prelude.Curry
  t0) => Data.Curry_RedBlackTree.C_RedBlackTree t0
  -> Data.Curry_RedBlackTree.C_RedBlackTree t0 -> IDSupply -> Cover
  -> ConstStore -> Data.Curry_RedBlackTree.C_RedBlackTree t0
nd_C_union x1 x2 s cd cs = let s5 = s
  in s5 `seq` (let s4 = leftSupply s5
                   s6 = rightSupply s5
                   s0 = leftSupply s6
                   s3 = rightSupply s6
  in s4 `seq` (s6 `seq` (s0 `seq` (s3 `seq` Curry_Prelude.nd_C_foldr
  (nd_C_insert s0 cd cs) x2 (let s2 = leftSupply s3
                                 s1 = rightSupply s3
  in s2 `seq` (s1 `seq` Curry_Prelude.nd_C_apply (nd_C_toList s1 cd cs) x1 s2 cd
  cs)) s4 cd cs))))

d_C_intersection :: forall t0 . (Curry_Prelude.Curry
  t0) => Data.Curry_RedBlackTree.C_RedBlackTree t0
  -> Data.Curry_RedBlackTree.C_RedBlackTree t0 -> Cover -> ConstStore
  -> Data.Curry_RedBlackTree.C_RedBlackTree t0
d_C_intersection x1 x2 cd cs = Curry_Prelude.d_C_foldr (d_C_insert cd cs)
  (Data.Curry_RedBlackTree.d_C_newTreeLike x1 cd cs) (Curry_Prelude.d_C_filter
  (Curry_Prelude.d_C_flip d_C_member x2) (Curry_Prelude.d_C_apply (d_C_toList cd
  cs) x1 cd cs) cd cs) cd cs

nd_C_intersection :: forall t0 . (Curry_Prelude.Curry
  t0) => Data.Curry_RedBlackTree.C_RedBlackTree t0
  -> Data.Curry_RedBlackTree.C_RedBlackTree t0 -> IDSupply -> Cover
  -> ConstStore -> Data.Curry_RedBlackTree.C_RedBlackTree t0
nd_C_intersection x1 x2 s cd cs = let s8 = s
  in s8 `seq` (let s9 = leftSupply s8
                   s10 = rightSupply s8
                   s7 = leftSupply s9
                   s0 = rightSupply s9
                   s1 = leftSupply s10
                   s6 = rightSupply s10
  in s9 `seq` (s10 `seq` (s7 `seq` (s0 `seq` (s1 `seq` (s6 `seq`
  Curry_Prelude.nd_C_foldr (nd_C_insert s0 cd cs)
  (Data.Curry_RedBlackTree.nd_C_newTreeLike x1 s1 cd cs) (let s5 = leftSupply s6
                                                              s4 = rightSupply
                                                                s6
  in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_filter (wrapNX id
  (Curry_Prelude.nd_C_flip (wrapNX id nd_C_member) x2)) (let s3 = leftSupply s4
                                                             s2 = rightSupply s4
  in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (nd_C_toList s2 cd cs) x1 s3 cd
  cs)) s5 cd cs)) s7 cd cs))))))

d_C_sortBy :: forall t0 . (Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> Cover
  -> ConstStore -> (t0 -> Cover -> ConstStore -> t0 -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool) -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
  -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C_sortBy x1 cd cs = acceptCs id (Data.Curry_RedBlackTree.d_C_sortBy x1)

nd_C_sortBy :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> IDSupply
  -> Cover -> ConstStore -> Func (Func t0 (Func t0 Curry_Prelude.C_Bool)) (Func
  (Curry_Prelude.OP_List t0) (Curry_Prelude.OP_List t0))
nd_C_sortBy x1 s cd cs = wrapDX (wrapNX id) (acceptCs id
  (Data.Curry_RedBlackTree.nd_C_sortBy x1))

